;3D Maussteuerung---------------------------------------------------------------

Const ScreenX =1024					;Auflsung Horizontal
Const ScreenY = 768					;Auflsung Vertikal
Graphics3D screenx,screeny,32,2		

Include "pathfinding.bb"

SeedRnd(MilliSecs())				;Zufallsgenerator initialisieren

Global FPSSEC = MilliSecs(), FPS, FRAMES 	;Einige Globale fr FPS Messung
Const  aStep# = 0.025						;Schrittweite fr unseren Character  Experementieren !!
Global Abstand#								;Abstand zwischen Man und ZielObjekt
Global LastMode$ ="Run"						;Letzte Einstellung fr Rennen oder Gehen	
Global AniMode$ = "Idle"    				;Aktuelle Animationssequenz
Global ZielPosX								;X Position zu der der Character gehen soll
Global ZielPosZ								;Z Position zu der der Character gehen soll
											;Man beachte das die Zielvariablen INteger Werte sind
											;So werden automatisch werte fr ein 2D array erzeugt
											;Wichtig fr den spteren Pathfinding Prozess
	
Idle_Mode = Rand(2,10)						;Idle_Mode = eine der vielen Animationssequenzen
											;des Characters wenn er nur in der Gegend rumsteht.
ShowInfo = 1 								;Textinformationen Anzeigen
Global Offset = 50
Global TurnSpeed = 1

;Character Animation------------------------------------------------------------
Global man = LoadAnimMesh("mesh\hu_ma_dieb.b3d")
EntityType man,1
Ani1 = LoadAnimSeq(man,"mesh\hu_ma_nc_ani.b3d")
Dim Ani(20)
ani(0)  = ExtractAnimSeq(man,11,41,1)		;Gehen
ani(1)  = ExtractAnimSeq(man,1400,1420,1)  ; Laufen
ani(2)  = ExtractAnimSeq(man,54,114,1)
ani(3)  = ExtractAnimSeq(man,127,187,1)
ani(4)  = ExtractAnimSeq(man,200,260,1)
ani(5)  = ExtractAnimSeq(man,272,333,1)
ani(6)  = ExtractAnimSeq(man,346,466,1)  ; Strecken, Ghnen
ani(7)  = ExtractAnimSeq(man,479,564,1)  ; Erschpft
ani(8)  = ExtractAnimSeq(man,577,697,1)  ; Erschpft2 ; Betrunken
ani(9)  = ExtractAnimSeq(man,709,770,1)  ; Bejahend
ani(10)  = ExtractAnimSeq(man,782,798,1)  ; Salutieren
ani(11)  = ExtractAnimSeq(man,811,871,1)  ; Verbeugen
ani(12)  = ExtractAnimSeq(man,884,929,1)  ; Trinken
ani(13)  = ExtractAnimSeq(man,942,1002,1)  ; Lesen
ani(14)  = ExtractAnimSeq(man,942,1002,1)  ; Lesen
ani(15)  = ExtractAnimSeq(man,1015,1075,1)  ; Zuhren
ani(16)  = ExtractAnimSeq(man,1088,1148,1)  ; Erklrend
ani(17)  = ExtractAnimSeq(man,1161,1241,1)  ; Erzhlen
ani(18)  = ExtractAnimSeq(man,1254,1314,1)  ; Lachen
ani(19)  = ExtractAnimSeq(man,1327,1387,1)  ; Winken, Verabschieden
ani(20)  = ExtractAnimSeq(man,1327,1387,1)  ; Winken, Verabschieden
PositionEntity man,25,0,25


;Licht------------------------------------------------------------------------
Licht = CreateLight()
RotateEntity Licht, 45,45,0
AmbientLight 50,50,50

;Camera-----------------------------------------------------------------------
cam_piv = CreatePivot(man)
Global cam = CreateCamera(cam_piv)
PositionEntity cam, 0,2,-10
CameraZoom cam, 1.5


;Rudimentre Positionsanzeige zu der der Character laufen soll
Global mPoint = CreateSphere(4)
ScaleEntity mPoint, 0.3,0.02,0.3

;Boden
ground = CreatePlane(8)
tex = LoadTexture("tiles/TTR01_grass02.tga")
EntityTexture ground,tex
EntityPickMode ground,2						;Wichtige einstellung damit die Position mittels Camerapick ermittelt werden kann


timer=CreateTimer(60) 
SetBuffer BackBuffer()



;Map
;Hier wird eine Primitives Labyrinth erstellt bzw. vorbereitet um der Pathfinding Routine einen Sinn zu geben
Global BOX = CreateCube()		;Maueren
ScaleMesh BOX, 0.5 , 0.5, 0.5
EntityColor box,0,255,0
HideEntity box
Global Lab = CreateMesh()

Global rBox = CreateCube()		;Zielpunkte
ScaleMesh rBox, 0.5 , 0.5, 0.5
EntityColor rBox, 255,0,0  
HideEntity rBox

Global Way 						;Kompletter Zielweg als Mesh
create_Map(50,50)				;Vorsicht mit greren Dimensionen
pathmode = 0					;Es existiren 3 Pathfinding Methoden 0,1,2


Global walkthisway =False








;MAinloop ************************************************************************************************************
While Not KeyHit(1)

	camControl(cam_piv,cam)


	;Die eigentlich Maussteuerung mit den wichtigen Sachen
	If MouseHit(1) Then check_Mouse(MouseX(),MouseY(),Cam_Piv)


	If KeyHit(59) Then ShowInfo = 1 - ShowInfo ;F1

	If KeyHit(60) Then			;F2 Taste schalltet zwischen Rennen und Gehen um
		If AniMode = "Walk" Then 
			AniMode="Run"
			LastMode =AniMode
		ElseIf AniMode ="Run" Then
			AniMode = "Walk"
			LastMode =AniMode
		EndIf
	EndIf
	
	

	
		

	;Bewegungsanimation nur Abspielen wenn ein Weg vorhanden ist
	If walkthisway = False Then
		animode ="Idle"  ;Mit Abstand experementieren
	Else
	
	
		;Permanente berprfung der Distanz	
		;Der letzte Knoten ist immer unser nchstes Ziel
		path.path=Last path

		If Handle(path) <> 0 Then
			;Distance(EntityX(mpoint), EntityZ(mpoint),EntityX(man), EntityZ(man))
			Distance(path\node\x, path\node\y,Int(EntityX(man)), Int(EntityZ(man)))
			
			Winkel# = getwinkel(path\node\x, path\node\y,EntityX(man), EntityZ(man))
			DebugLog "Winkel: " +winkel

			;Ausrichten des Characters auf Zielposition 
			RotateEntity man,0,winkel#,0				  ; Character auf neue Position Ausrichten	
			RotateEntity cam_piv,EntityPitch(cam_piv),-winkel,0   ; Camera entgegengesetzt ausrichten

		Else
			walkthisway = False	
		EndIf
		
		; Einfach aktuellen Knoten Lschen um den nchsten anzuwhlen
		If abstand = 0 Then
			Delete path.path

		EndIf
		
	
	
		If AniMode = "Walk"  Then
			If AnimSeq(man) <> ani(0) Then 	Animate man,1,0.5,ani(0),5
			;Schritt nach vorne Berechnen
			z# = z# - 0.025
			;Mesh Verschieben
			MoveEntity man, 0,0,-aStep
		EndIf
			
		If AniMode = "Run"  Then
			If AnimSeq(man) <> ani(1) Then 	Animate man,1,0.5,ani(1),5
			;Schritt nach vorne Berechnen
			z# = z# - 0.06
			;Mesh Verschieben
			MoveEntity man, 0,0,-0.05
		EndIf
	EndIf
		

	If AniMode = "Idle"  Then
		If AnimSeq(man) <> ani(Idle_Mode) Then  Animate man,1,0.5,ani(Idle_Mode),5

		;Wenn Idle Animation abgelaufen per Zufall neue auswhlen
		If AnimTime(man) >= AnimLength(man)-1 Then
			Idle_Mode = Rand(2,20)
		EndIf
	EndIf		





	UpdateWorld
	RenderWorld
	If ShoWInfo = True Then
		Color 255,255,255
		Text 0,0, "3D Maussteuerung fr z.B. RPG Games   Linksklick = Bewegung"
		Text 0,20, "FPS: "+FPS(1)
    	Text 0,40, "Sequence: "+AnimSeq (man) + " " +animode$ + "   Lnge: " +AnimLength(man) +" Frame: " +AnimTime(man)
	    Text 0,60, "Position  " + EntityX(man) +" /" + EntityZ(man)
		Text 0,80, "ZielPos X|Z " +zielPosX +"|" +ZielPosZ
		Text 0,100, "Abstand: " +abstand
		Color 255,0,0
		Text 0,120, "F1 = Infos Ein / Ausschalten"
		Text 0,140, "F2 = Gehen / Rennen umschalten"
		Text 0,160, "Nummernblock = camerasteuerung"
		Text 0,180, "Tastenbelegung: 8|2|4|6|+|-"
	EndIf
	Flip WaitTimer(timer)
Wend
End




;Camerasteuerung Ohne grossartige Kommentare

Function CamControl(p,c)
	pitch# 	=	EntityPitch(p)
	Yaw# 	= 	EntityYaw(p)
	Roll# 	= 	EntityRoll(p)
	
	If KeyDown(77) Yaw = yaw +TurnSpeed		; NumLock 6
	If KeyDown(75) Yaw = yaw -TurnSpeed		; Num Lock 4
	If KeyDown(72) pitch = pitch +TurnSpeed ; Num Lock 8
	If KeyDown(80) pitch = pitch -TurnSpeed ; Num Lock 2
	
	If KeyDown(78) PositionEntity c,0,EntityY(c),EntityZ(c)+0.1  	; Num Lock + Zoom In
	If KeyDown(74) PositionEntity c,0,EntityY(c),EntityZ(c)-0.1  	; Num Lock - Zoom Out
	
	If pitch <1 Then pitch = 1
	If pitch >89 Then pitch =89
	RotateEntity p,pitch,yaw,Roll
End Function



;Wird beim Klicken mit Linker Maustaste ausgefhrt
;Hier sind die wirklich wichtigen Sachen um die Steuerung zu demonstrieren
Function Check_Mouse(x,y,p);------------------------------------------------------------------------------------------
	
		
	CameraPick(cam,x,y)       ; Neue Zielposition auf dem Grid mittels CameraPick holen 
	zielposx = PickedX()	  ; Zwischenspeichern der Positionsdaten 	
	zielposz = PickedZ()

	;Keine Zielpunkte ausserhalb des Irrgartens anklickbar
	If zielposX >mapwidth Or zielposx < 0 Or zielposZ > mapheight Or zielposz < 0 Then Return
	
	
	FreeEntity way				;Der Zielweg wird gelscht
	way	= CreateMesh()			; und direkt wieder erstellt
	

	;Unser Zielpositionsanzeiger an Mausposition setzen
	PositionEntity mpoint,zielposx,0.01,zielPosz

	;Wegfindung einleiten
;	pathfinding2(startx,starty,endx,endy)
	DebugLog Int(EntityX(man))+ "  " +Int(EntityZ(man))+ "  "+zielposx+ "  "+zielposz

	If pathmode=0 Then pathfinding0(Int(EntityX(man)),Int(EntityZ(man)),zielposx,zielposz)
  	If pathmode=1 Then pathfinding1(Int(EntityX(man)),Int(EntityZ(man)),zielposx,zielposz)
  	If pathmode=2 Then pathfinding2(Int(EntityX(man)),Int(EntityZ(man)),zielposx,zielposz)


	
	
	
	;Wgfindung optisch darstellen
	nodes3 = 0
	For path.path=Each path
    	tmesh= CopyMesh(rBox)
		PositionMesh tmesh,path\node\x,0.5,path\node\y
		AddMesh tmesh,way
		FreeEntity tmesh
    	nodes3=nodes3+1
	Next
	EntityColor way,255,0,0
	PositionEntity way, 0,-0.9,0
	DebugLog "Anzahl der Zielpunkte: " +nodes3
	
	
	
	;Wurde eine Weg gefunden?
	If nodes3 >0 Then 
		WalkThisWay = True
		aniMode = LastMode   ;Letzte Bewegungsanimation (Wlak / Run) wieder einschalten


		;Um wieviel grad muss der Character sich drehen um auf die neue Zielposition ausgerichtet zu werden?
		;Die neue Zielposition ist der vorletzte Knoten in der Wegfindung
		;Der Erste Knoten befindet sich an der endgltigen Zielposition
		;Der Letzte Knoten ist uninteressant da wir auf ihm draufstehen
		;Wir lschen also den letzten Knoten und gehen anschliesend zum neuen Letzen Knoten
	
		path.path = Last path
		Delete path.path
		path.path = Last path


		;jetzt den winkel Berechnen zum aktuellen Zielknoten 
		Winkel# = getwinkel(path\node\x, path\node\y,Int(EntityX(man)), Int(EntityZ(man)))
		DebugLog "Winkel: " +winkel

		;Ausrichten des Characters auf Zielposition 
		RotateEntity man,0,winkel,0				  ; Character auf neue Position Ausrichten	
		RotateEntity p,EntityPitch(p),-winkel,0   ; Camera entgegengesetzt ausrichten
	
	Else
		WalkThisWay = False
	EndIf
		
End Function



;Berechnet den Winkel zwischen Ausgangspunkt und Zielpunkt
Function getwinkel(ZX#,ZZ#,AX#,AZ# ) 
	grad# =ATan2(ZZ -AZ, ZX -AX)+90; verschiebt die 0 Grad Position auf korrekte werte
	If grad# < 0 Then grad# = grad#+360 
	Return grad# 
End Function


;Berechnet den Abstand zwischen Ausgangspunkt und Zielpunkt
Function Distance(x1#,z1#,x2#,z2#)
	Abstand=Sqr((X1#-X2#)^2+(z1#-z2#)^2)
End Function

;Erstellt eine Rudimnter Map in gre vom Map Array mit boolean Werten fr Blockiert, Nicht Blockiert
;Wir befinden uns zwar im 3D Mode verwenden aber hier fr Positionsangaben NUR Positive Werte

Function Create_Map(width,height,Labstart=1)

	mapwidth=width-1
	mapheight=height-1

	Dim map(width-1,height-1)
  	Dim sqrmap(width-1,height-1)
  	For y=0 To mapheight
    	For x=0 To mapwidth
	      	sqrmap(x,y)=Sqr(x*x+y*y)
			map(x,y) = Rand(0,1)
			
			;Eine Aussparung damit wir in jedem Fall etwas laufen knene
			If y = mapheight/2-1 Or y = mapheight/2 Or y = mapheight/2+1 Then map(x,y) = 0
			If x = mapwidth/2-1 Or x = mapwidth/2 Or x = mapwidth/2+1 Then map(x,y) = 0
			
			
			If map(x,y) =1 Then
				tmpBox =CopyMesh(box)
				PositionMesh tmpBox,x,0,y
				AddMesh tmpbox,Lab				
				FreeEntity tmpBox		
			EndIf
		Next
	Next
	
PositionEntity lab, 0,-1,0
EntityColor lab,0,255,0


;Irrgarten ein bischen Animieren.  Ist nur Show
While Labstart = 1 
	PositionEntity lab, 0,EntityY(lab)+0.01,0
	If EntityY(lab) >=0.8 Then labstart =0
	PositionEntity cam,EntityX(cam),EntityY(cam)+.1,EntityZ(cam)-.03
       RotateEntity cam,EntityPitch(cam)+0.3,0,0

	RenderWorld
	Text 0,0, "Creating Labyrinth"
	Flip
Wend




End Function


;Berechnet di FPS
Function FPS(MODE) ;----------------------------------------------------------------------------
	If MODE = 1 Then 
		FRAMES = FRAMES + 1 
		If MilliSecs() - FPSSEC => 1000 Then 
			FPS = FRAMES 
			FRAMES = 0 
			FPSSEC = MilliSecs() 
		EndIf 
	EndIf 
	Return FPS 
End Function